#@cmdln.option('

# it might make sense to add an option to attempt to merge patches.

def do_mergefrom(self, subcmd, opts, project, package):
    """${cmd_name}: Merge from another package

    *** WARNING ***
    Use with caution!  This functionality is not ready yet!
    
    Examples:
      mergefrom GNOME:Community pidgin

    ${cmd_usage}
    ${cmd_option_list}"""

    from oscpluginsgnome.utils import hash_file
    from oscpluginsgnome.utils import diff3
    import pickle
    import hashlib
    import os
    from sets import Set
    from commands import getstatusoutput

    cc = conf.config['apiurl']

    our_files = Set(os.listdir('.'))
    
    # we don't care about the .osc directory
    our_files.discard('.osc')

    other_files = meta_get_filelist(cc, project, package)
    their_files = Set(other_files)
    
    
    for file in other_files:
        target = "%s.to-merge" % file
        get_source_file(cc, project, package, file, targetfilename=target)
        # print "Added %s" % target
        pass
    
    if len((our_files - their_files)) > 0:
        print "These files are unique to this copy:"
        for file in (our_files - their_files):
            print "    %s" % file
            pass
        pass

    if len((their_files - our_files)) > 0:
        print "These files are unique to the other copy:"
        for file in (their_files - our_files):
            print "    %s" % file
            pass
        pass
    
    is_different = {}
    # print "These files are found in both:"
    for file in (our_files & their_files):
        # print "    %s" % file
        fh = {}
        our = hash_file(file)
        their = hash_file("%s.to-merge" % file)
        if our != their:
            is_different[file] = True
        else:
            is_different[file] = False
            # so why keep the other copy around?
            os.unlink("%s.to-merge" % file)
            pass
        pass
    
    f = None
    print "These are the files that are different:"
    for file in is_different.keys():
        if is_different[file]:
            print "    %s is different" % file
            if file.endswith(".patch") or file.endswith(".dif") or \
                    file.endswith(".diff") or file.endswith(".gz") or \
                    file.endswith(".bz2") or file.endswith(".zip"):
                print "        but we won't try to merge it."
                continue
            else:
                # print "we are about diff3 -m %s %s %s" % \
                #     (file, ".osc/%s" % file, "%s.to-merge" % file)
                # This is pretty broken.  
                ### status, output = diff3(file, 
                ### ".osc/%s" % file,
                ###                       "%s.to-merge" % file)
                status = 2
                # print "status = %d" % status
                if status == 0:
                    os.unlink("%s.to-merge" % file)

                    f = open("%s.tmp" % file, 'w')
                    f.write(output)
                    f.close()
                    # FIXME: check these (and others)
                    mvstatus, mvoutput = getstatusoutput("mv %s.tmp %s" \
                                                             % (file, file))

                    print "        %s: merged successfully" % file
                elif status == 1:
                    os.unlink("%s.to-merge" % file)
                    
                    f = open("%s.to-merge" % file, 'w')
                    f.write(output)
                    f.close()
                    print "        %s: failed to merge.  Leftover file in %s.to-merge" % \
                        (file, file)
                else:
                    # it totally failed
                    print "        merging not attempted; please inspect %s.to-merge" % file
                    print "        and attempt to merge yourselfile."
                    pass
            # print "%s and %s" % (is_different[f]['our'], is_different[f]['their'])
                pass
            pass
        pass
    pass




