def do_nukebranch(self, subcmd, opts, project, package):
    """${cmd_name}: Delete a branch of a package.  Use with care!

    Examples:
      nukebranch GNOME:Factory glib2
    
    This is a sharp tool!  Use with caution!
    ${cmd_usage}
    ${cmd_option_list}
    """

    me = conf.config['user']
    apiurl = conf.config['apiurl']

    real_project = "home:%s:branches:%s" % (me, project)
    real_package = package

    # So that we'll get failures later if we use the "unlaundered" variables by mistake
    project = None
    package = None

    import re
    confirm_exp = re.compile("[Yy]([eE][sS]){0,1}")
    print ""
    confirm_input = raw_input("Really delete %s/%s?  (y/n): " % (real_project, real_package))
    
    if not confirm_exp.match(confirm_input):
        print "Playing it safe, eh?  I'll leave it alone."
        return
    
    delete_package(apiurl, real_project, real_package)
