# This is a template, before making any further amendments, do the following
# search & replace actions:
#
# PACKAGE  => package-name
# VERSION  => package version
# YOURNAME => Your name
# FEEDBACK => Your email address
#
# Then, fill in the BuildRequires line as appropriate.  Some basic packages are
# listed for you, but you'll need to add packages that the configure script
# fails to find.
#
# Don't forget that every package installs different files, so you need to
# populate the %files section appropriately.
#
# An example %doc line is provided but you may need to tweak it.
#
# Note that the Summary, Release, and Group parts of the preamble are
# automatically filled in/replaced by the internal build system based
# on information stored in the PDB.  The same applies to the %description.
#
# provided, you will likely need to add more.
# After that, you may remove this line and all above it.
#
# spec file for package PACKAGE (version VERSION)
#
# Copyright (c) 2009 YOURNAME
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

Name:           PACKAGE
Version:        VERSION
Release:        1
License:        GPLv2 or later
Summary:        
Url:            
Group:          
Source0:        %{name}-%{version}.tar.bz2
BuildRequires:  gconf2-devel
BuildRequires:  intltool
BuildRequires:  update-desktop-files
Requires:       %{name}-lang = %{version}
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%gconf_schemas_prereq

%description
Insert description here - normally taken from the README.

%lang_package

%prep
%setup -q

%build
%configure --disable-static
%__make %{?jobs:-j%jobs}

%install
%makeinstall
find %{buildroot} -type f -name "*.la" -delete -print
%find_gconf_schemas
%suse_update_desktop_file %{name}
%find_lang %{name}

%pre -f %{name}.schemas_pre
%preun -f %{name}.schemas_preun
%posttrans -f %{name}.schemas_posttrans

%clean
%{__rm} -rf %{buildroot}

%files -f %{name}.schemas_list
%defattr(-, root, root)
%doc AUTHORS NEWS README TODO
%{_bindir}/*
%{_datadir}/applications/*

%files lang -f %{name}.lang

%changelog
